#Runner-QT v.1 Copyright (c) 2017 JJ Posti <techtimejourney.net> 
#This program comes with ABSOLUTELY NO WARRANTY; 
#for details see: http://www.gnu.org/copyleft/gpl.html. 
#This is free software, and you are welcome to redistribute it under 
#GPL Version 2, June 1991")
#!/usr/bin/env python
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtCore import Qt  
from PyQt5.QtWidgets import QMainWindow, QVBoxLayout, QLineEdit, QCheckBox, QToolBar, QMenu, QMessageBox, QPushButton, QApplication
import subprocess, os, sys
class Main(QMainWindow):
    def __init__(self, *args, **kwargs):
        super(Main, self).__init__(*args, **kwargs)
#Title & Layout		
        self.setWindowTitle("Runner-QT")
        self.setFixedSize(500, 40)
        self.move(QApplication.desktop().screen().rect().center()- self.rect().center())
        self.vertical = QVBoxLayout()
#Text field
        self.address=QLineEdit()
        self.address.setFixedSize(280, 34)
        self.address.setAlignment(Qt.AlignCenter)
        self.address.returnPressed.connect(self.navigate0)
#Checkbox button
        self.check = QCheckBox('Normal mode', self)
        self.check.toggle()
        self.check.stateChanged.connect(self.navigate)
#Launch button for the shell mode
        self.launch = QPushButton()
        self.launch.setObjectName("Shell Launch")
        self.launch.setText("Shell Launch")
        self.launch.setEnabled(False)
        self.launch.clicked.connect(self.navigatex)              
#Toolbar & Layout
        self.toolbar=QToolBar()
        self.toolbar.addWidget(self.launch)
        self.toolbar.addWidget(self.address)
        self.toolbar.addWidget(self.check)
        self.addToolBar(self.toolbar)
        self.toolbar.setLayout(self.vertical)  
        self.setLayout(self.vertical)
#Right-Click menu & About messagebox
    def contextMenuEvent(self, event):
        self.menu = QMenu(self)        
        self.about1 = self.menu.addAction('About')
        self.about1.triggered.connect(self.about)        
    # add other required actions
        self.menu.popup(QtGui.QCursor.pos())
#About messagebox
    def about(self):
        buttonReply = QMessageBox.question(self, 'Runner-QT v.1 Copyright (c) 2017 JJ Posti <techtimejourney.net>', "Runner-QT  is a dialog for running programs. The program comes with ABSOLUTELY NO WARRANTY  for details see: http://www.gnu.org/copyleft/gpl.html. This is free software, and you are welcome to redistribute it under GPL Version 2, June 1991.\n \nNormal mode runs programs without arguments (single word like clfm, firefox etc.). Shell mode runs programs via shell and accepts arguments (Example: firefox www.google.fi or albix for Albix Player).\n \nShell mode can open and execute scripts, so be cautious when using shell mode and do not open things without thinking what you do.", QMessageBox.Ok )
        if buttonReply == QMessageBox.Ok:
            print('Ok clicked, messagebox closed.')
###########################################            
    def navigate0(self):
        location=self.address.text()
        subprocess.Popen(location)
        self.close()

    def navigatex(self):
        location=self.address.text()
        subprocess.Popen(location, shell=True)
        self.close()                                    
             
    def navigate(self,status):
            location=self.address.text()
            if status == Qt.Checked:
                self.setWindowTitle('Runner-QT')
                self.launch.setEnabled(False)
            elif not status==Qt.Checked:
                self.setWindowTitle('Caution: Shell mode is enabled')
                self.launch.setEnabled(True)

if __name__ == '__main__':
    app = QApplication(sys.argv)
    window = Main()
    window.show() 
    sys.exit(app.exec_())
